-- ------------------------------------------------------------------------------ --
--                           TradeSkillMaster_Vendoring                           --
--           http://www.curse.com/addons/wow/tradeskillmaster_vendoring           --
--                                                                                --
--             A TradeSkillMaster Addon (http://tradeskillmaster.com)             --
--    All Rights Reserved* - Detailed license information included with addon.    --
-- ------------------------------------------------------------------------------ --

local TSM = select(2, ...)
local Groups = TSM:NewModule("Groups", "AceEvent-3.0", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("TradeSkillMaster_Vendoring") -- loads the localization table

local private = { }

function Groups:OnEnable()

end

function Groups:CreateTab(parent)

	local frame = CreateFrame("Frame", nil, parent)
	frame:Hide()
	frame:SetAllPoints()
	
	local stContainer = CreateFrame("Frame", nil, frame)
	stContainer:SetPoint("TOPLEFT", 5, -45)
	stContainer:SetPoint("BOTTOMRIGHT", -5, 55)
	TSMAPI.Design:SetFrameColor(stContainer)
	frame.groupTree = TSMAPI:CreateGroupTree(stContainer, "Vendoring", "Vendoring_Vendor")	
	
	local function OnSellButtonClick(self)
			private:SellButtonClick()
		
	end

	local function OnBuyButtonClick(self)
		
			private:BuyButtonClick()
		
	end	
	
	local sellButton = TSMAPI.GUI:CreateButton(frame, 15)
	sellButton:SetPoint("BOTTOMLEFT", 5, 25)	
	sellButton:SetHeight(25)
	sellButton:SetWidth(150)
	sellButton:SetText(L["Sell Selected Groups"])
	sellButton:SetScript("OnClick", OnSellButtonClick)
	frame.sellButton = sellButton
	
	local buyButton = TSMAPI.GUI:CreateButton(frame, 15)
	buyButton:SetPoint("BOTTOMLEFT", frame.sellButton, "BOTTOMRIGHT",10, 0)
	buyButton:SetHeight(25)
	buyButton:SetWidth(150)
	buyButton:SetText(L["Buy Selected Groups"])
	buyButton:SetScript("OnClick", OnBuyButtonClick)
	frame.buyButton = buyButton	
	
	private.frame = frame
	return frame
end

function private:SellButtonClick()

	local inventoryItems = {}
	for bag, slot, itemString, quantity, locked in TSMAPI:GetBagIterator(false) do
		inventoryItems[itemString] = (inventoryItems[itemString] or 0) + quantity
	end

	for _, data in pairs(private.frame.groupTree:GetSelectedGroupInfo()) do
		for _, operationName in ipairs(data.operations) do
				local operation = TSM.operations[operationName]
				
				for itemString in pairs(data.items) do
					print(operationName..": "..itemString)
				end
		end
	end
end

function private:BuyButtonClick()

	local numMerchantItems = GetMerchantNumItems();
	
	local inventoryItems = {}
	for bag, slot, itemString, quantity, locked in TSMAPI:GetBagIterator(false) do
		inventoryItems[itemString] = (inventoryItems[itemString] or 0) + quantity
	end
			
	for index = 1, numMerchantItems do
		local name, texture, price, stackCount, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(index)
		local vendorItemLink = GetMerchantItemLink(index)
		local vendorItemString = TSMAPI:GetItemString(vendorItemLink)
				
		for _, data in pairs(private.frame.groupTree:GetSelectedGroupInfo()) do
			for _, operationName in ipairs(data.operations) do
					local operation = TSM.operations[operationName]
					
					for itemString in pairs(data.items) do						
						if vendorItemString == itemString then
							print(vendorItemString)
							print(name)
							print(operationName..": "..vendorItemLink)
						end
					end
			end
		end
	end
end